// CppClientDlg.h : header file
//

#pragma once

#include "afxwin.h"
#include "afxcmn.h"
#include "UserVideoDlg.h"
#include <set>
#include <map>


// CCppClientDlg dialog
class CCppClientDlg : public CDialog
{
// Construction
public:
	CCppClientDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_CPPCLIENT_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	void ShowDevices(SoundSystem nSoundSys);

	void AddMsg(CString szMsg);

// Implementation
protected:
	HICON m_hIcon;
	LPVOID m_pTTInstance;
	std::set<int> m_users;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();

	//the WM_TEAMTALK_* message handlers
	afx_msg LRESULT OnConnectFailed(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnConnectSuccess(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnConnectionLost(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnLoggedIn(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnLoggedOut(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnKicked(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnServerUpdate(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnCommandError(WPARAM wParam, LPARAM lParam);

	afx_msg LRESULT OnAddUser(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnUpdateUser(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnRemoveUser(WPARAM wParam, LPARAM lParam);

	afx_msg LRESULT OnAddChannel(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnUpdateChannel(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnRemoveChannel(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnChannelJoined(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnChannelLeft(WPARAM wParam, LPARAM lParam);

	afx_msg LRESULT OnAddFile(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnRemoveFile(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnFileTransferUpdate(WPARAM wParam, LPARAM lParam);


	afx_msg LRESULT OnTextMessage(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnChannelMessage(WPARAM wParam, LPARAM lParam);

	afx_msg LRESULT OnUserTalking(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnUserVideoFrame(WPARAM wParam, LPARAM lParam);

	afx_msg LRESULT OnPeer2PeerCon(WPARAM wParam, LPARAM lParam);

	afx_msg LRESULT OnUserVideoDlg(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
	virtual void OnOK();
	virtual void OnCancel();
public:
	CComboBox m_wndInput;
	CComboBox m_wndOutput;
	CEdit m_wndAddress;
	CEdit m_wndHostPort;
	CEdit m_wndSoundPort;
	CEdit m_wndJoinChannel;
	afx_msg void OnBnClickedRadio1();
	afx_msg void OnBnClickedRadio2();
	afx_msg void OnBnClickedButton1();
	afx_msg void OnBnClickedButton2();
	afx_msg void OnBnClickedButton3();
	afx_msg void OnBnClickedButton4();
	afx_msg void OnBnClickedButton5();
	CButton m_wndDSound;
	CButton m_wndWinmm;
	CButton m_wndInitSound;
	CButton m_wndCloseSound;
	CButton m_wndConnect;
	CButton m_wndDisconnect;
	CButton m_wndJoin;
	CEdit m_wndStatus;
	CListBox m_wndUsers;
	CSliderCtrl m_wndUserVol;
	afx_msg void OnLbnSelchangeList1();
	CButton m_wndUserMute;
	afx_msg void OnBnClickedCheck1();
	afx_msg void OnNMCustomdrawSlider1(NMHDR *pNMHDR, LRESULT *pResult);
	CSliderCtrl m_wndMasterVol;
	CProgressCtrl m_wndVUMeter;
	CSliderCtrl m_wndVoiceAct;
	afx_msg void OnNMCustomdrawSlider2(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawSlider3(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedButton6();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnBnClickedButtonLeave();
	CEdit m_wndNickname;
	CEdit m_wndSPassword;
	CEdit m_wndCPassword;
	CButton m_wndLogout;
	CButton m_wndLeave;
	afx_msg void OnBnClickedButton7();
	afx_msg void OnBnClickedButton8();
	CButton m_wndLogin;
	afx_msg void OnCbnSelchangeCombo1();
	CSliderCtrl m_wndUserGain;
	afx_msg void OnNMCustomdrawSlider4(NMHDR *pNMHDR, LRESULT *pResult);
	CSliderCtrl m_wndVoiceGain;
	afx_msg void OnNMCustomdrawSlider5(NMHDR *pNMHDR, LRESULT *pResult);
	CListBox m_wndFiles;
	CButton m_wndDownload;
	CButton m_wndUpload;
	afx_msg void OnBnClickedButton9();
	afx_msg void OnBnClickedButton10();
	afx_msg void OnBnClickedButton11();
	CButton m_wndDelete;
	CComboBox m_wndMixerInput;
    CEdit m_wndUsername;
    CEdit m_wndPassword;
    CListBox m_wndChannels;
	afx_msg void OnLbnSelchangeList3();
    typedef std::map<int, CUserVideoDlg*> videodlgs_t;
    videodlgs_t m_videodlgs;
    CButton m_wndTransmit;
};
