using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using BearWare;

namespace TeamTalk.NET
{
    public partial class ServerStatsDlg : Form
    {
        TeamTalk4 ttclient;
        int cmd_id;

        public ServerStatsDlg(TeamTalk4 tt)
        {
            InitializeComponent();
            ttclient = tt;

            ttclient.OnCmdSuccess += new TeamTalk4.CommandSuccess(ttclient_OnCmdSuccess);

            cmd_id = ttclient.DoQueryServerStats();
            this.CenterToScreen();
        }

        void ttclient_OnCmdSuccess(int nCmdID)
        {
            if (cmd_id == nCmdID)
            {
                ServerStatistics stats;
                if (ttclient.GetServerStatistics(out stats))
                {
                    totalTextBox.Text = String.Format("{0}/{1} KBytes", stats.nTotalBytesRX / 1024, stats.nTotalBytesTX / 1024);
                    voiceTextBox.Text = String.Format("{0}/{1} KBytes", stats.nVoiceBytesRX / 1024, stats.nVoiceBytesTX / 1024);
                    videoTextBox.Text = String.Format("{0}/{1} KBytes", stats.nVideoBytesRX / 1024, stats.nVideoBytesTX / 1024);
                }
            }
        }

        private void updButton_Click(object sender, EventArgs e)
        {
            cmd_id = ttclient.DoQueryServerStats();
        }
    }
}